<?php
$host = "www.verrotech.net";
if (isset($_SERVER['argv'][1])) $host=$_SERVER['argv'][1];

$opt_useadd = true;
$opt_shuffle = true;

$dns_cache = array();

function dnsc_add($host, $ip)
{
	global $dns_cache;
	$dns_cache[$host]=$ip;
}

function dnsc_lookup($host)
{
	global $dns_cache;
	if (isset($dns_cache[$host])) return $dns_cache[$host];
	else return gethostbyname($host);
}

$maxdepth=10;

require("phpdns/dns.inc.php");

$roots = array(
	"a.root-servers.net",
	"b.root-servers.net",
	"c.root-servers.net",
	"d.root-servers.net",
	"e.root-servers.net",
	"f.root-servers.net",
	"g.root-servers.net",
	"h.root-servers.net",
	"i.root-servers.net" );
if ($opt_shuffle) shuffle($roots);

function dots($depth)
{
	$out="";
	for($a=0; $a<$depth; $a++) $out.=".";
	if ($depth>0) $out.=" ";
	return $out;
}

function dns_rr($host, $serverlist, $depth=0, $offset=0)
{
	global $maxdepth,$opt_shuffle;
	if ($depth>$maxdepth) return false;
	
	if (!isset($serverlist[$offset])) return false;
	$server=$serverlist[$offset];
	
	$serverip=dnsc_lookup($server);
	
	echo dots($depth).$server." (".$serverip."): ";
	
	$dns = new DNSQuery($serverip, 53, 20, false);
	
	$result = $dns->Query($host, "A");
	
	$trynext=false;
	$goodresult=false;
	$nslookup=true;
	
	if ($dns->error != 0)
	{
		echo "Error";
		$trynext=true;
	}
	else if ($result===false)
	{
		echo "False";
		$trynext=true;
	}
	else
	{
		if (count($result->results)>0)
		{
			echo "Result: ";
			$first=true;
			foreach($result->results as $res)
			{
				if ($res->typeid=="A")
				{
					if ($first) $first=false;
					else echo ", ";
					echo $res->data;
				}
			}
			$goodresult=true;
		}
		else
		{
			echo "Response";
			if ($dns->lastnameservers->count>0)
			{
				echo " with nameservers";
				$nextns=array();
				foreach($dns->lastnameservers->results as $ns)
				{
					if ($ns->typeid=="NS") $nextns[]=$ns->data;
				}
				foreach($dns->lastadditional->results as $add)
				{
					if ($add->typeid=="A") dnsc_add($add->domain, $add->data);
				}
				if ($opt_shuffle) shuffle($nextns);
				
				$nslookup=true;
			}
			else echo " without nameservers";
				
		}
	}
	
	echo "\n";
	
	if ($trynext) return dns_rr($host, $serverlist, $depth, $offset+1);
	else if ($goodresult) return true;
	else if ($nslookup) return dns_rr($host, $nextns, $depth+1, 0);
	else return false;
	
	echo "\n";
}

echo "Resolving ".$host."\n";
if (!dns_rr($host, $roots)) echo "Query Failed to Return A Record\n";
?>